
sub expand_node {

    my($f_no_words_prev,$node_in_stack,$f_tokens,$node_id,$stack,$max_in_stack,$min_in_full_stack,$match_trans,$future_cost_spans,$nodes_lpos,$nodes_rpos,$nodes_last,$nodes_cov,$nodes_cos,$nodes_tc,$nodes_back,$nodes_tr,$nodes_recomb_back,$nodes_cos_nolm,$recombine_info,$parameters,$features,$lm_srilm_ids,$nbest_sent,$rescore_mode,$generate_rescore_lattice,$rescore_lattice,$nbest_trans_map,$translation_order,$individual_costs,$lm_cache,$lm_between_cache,$e_phrase_prefixes,$nodes_favorite_child_cost,$nodes_label,$lattice,$lattice_translations,$lattice_costs,$sent_id)=@_;

    my $prev_node_id=$stack->[$f_no_words_prev][$node_in_stack];

    my $f_no_words=@$f_tokens;
    my $last_f_index=$f_no_words-1;

    my $prev_node_lpos=$nodes_lpos->[$prev_node_id];
    my $prev_node_rpos=$nodes_rpos->[$prev_node_id];

    my $favorite_child_cost=-99999;
    my $end_sent_symbol='</s>';

    my $use_lm_cache=0;
    $use_lm_cache=1 if($rescore_mode);

    my $unk_dm_next=0;
    my $unk_dm_previous=0;
    my $unk_token='UNK';

    my @orig_translation_order=@$translation_order;

#    my $next_total_cost;
#    if(defined($stack->[$f_no_words_prev][$node_in_stack+1])) {
#	$next_total_cost=$nodes_tc->[$stack->[$f_no_words_prev][$node_in_stack+1]];
#    }

    my @prev_cover_vec;
    my @end_of_sentence_marker=qw( </s> );

    my $prev_node_costs=$nodes_cos->[$prev_node_id];

    my @prev_e_words=@{ $nodes_last->[$prev_node_id] };

    my $distortion_costs;
    my $unweighted_distortion_costs;
    my $distortion_weight=$$features{'distortion_cost'};
#    my $lm_weight=$$features{'lm_weight'};

    my $beam_width=log($$parameters{'beam_width'});
    my $children_beam_width=log($$parameters{'children_beam_width'});
    my $suffix_length=$$parameters{'lm_order'}-1;
    my $lm_order=$$parameters{'lm_order'};
    my $max_phrase_length=$$parameters{'max_phrase_length'};
    my $f_no_words_next;
    my $future_costs=0;

    my $f_phrase;
    
    my $prev_f_phrase;
    my $prev_e_phrase;
    if($prev_node_lpos>=0) {
	$prev_f_phrase=join(' ',@$f_tokens[$prev_node_lpos..$prev_node_rpos]);
	$prev_e_phrase=$nodes_tr->[$prev_node_id];
    } else {
	$prev_f_phrase='<s>';
	$prev_e_phrase='<s>';
    }

    if(!exists($lex_dm{$prev_f_phrase})||!exists($lex_dm{$prev_f_phrase}{$prev_e_phrase})) {
        $unk_dm_previous=1;
    }

    my $prev_future_costs=0;
    my $first_zero=0;
    my @directions;
    my $prev_words_phrase=join(' ',@prev_e_words);
    my $e_phrase_prefix;
  
    my $current_node=-1;
    $current_node=$nodes_label->[$prev_node_id] if($rescore_lattice);

    # this outer foreach loop is only required for lattice rescoring
    # -1 is added as a fake node to get into the loop in case we're not rescoring a lattice
    foreach my $next_node (-1,keys (%{ $$lattice{$current_node} })) {
	my $rescore_l;
	my $rescore_r;

	if($rescore_lattice) {
	    next if($next_node==-1);
	    ($rescore_l,$rescore_r)=split(/ /,$$lattice{$current_node}{$next_node});
	}

	if(!$rescore_mode) {
	    @prev_cover_vec=char2cover(\$nodes_cov->[$prev_node_id],\$f_no_words);
# not necessary as the previous future costs are not used anywhere:
#	    $prev_future_costs=compute_future_costs(\@prev_cover_vec,$future_cost_spans);
	    for(my $i=0; $i<@prev_cover_vec; $i++) {
		if($prev_cover_vec[$i]==0) {
		    $first_zero=$i;
		    last;
		}
	    }
	    if($rescore_lattice) {
		if($rescore_l>$prev_node_rpos) {
		    @directions=qw( right );
		} else {
		    @directions=qw( left );
		}
	    } else {	
		@directions=qw( right left );	
	    }
	} else {
	    @prev_cover_vec=(0) x $f_no_words;
	    ($rescore_l,$rescore_r)=split(/ /,shift(@$translation_order));
	    if(!defined($rescore_l) || !defined($rescore_r)) {
		print STDERR "rescore_l=$rescore_l rescore_r=$rescore_r sent_id=$sent_id trans_order=@orig_translation_order\n";
	    }
	    if($rescore_l>$prev_node_rpos) {
		@directions=qw( right );
	    } else {
	    @directions=qw( left );
	    }
	}
    

	foreach my $direction (@directions) {
	    my $from;
	    my $to_inner;
	    my $to_outer;
	    my $rescore_phrase_length=0;

	    if($rescore_mode||$rescore_lattice) {
		if($direction eq 'right') {
		    $from=$rescore_l;
		    $to_inner=$rescore_l+1;
		    $to_outer=$rescore_r+1;
		    $rescore_phrase_length=$rescore_r-$rescore_l;
		} else {
		    $from=$rescore_r;
		    $to_inner=$rescore_r-1;
		    $to_outer=$rescore_l-1;
		    $rescore_phrase_length=$rescore_l-$rescore_r;
		}
	    } else {
		if($direction eq 'right') {
		    $from=$prev_node_rpos+1;
		    $to_inner=min($f_no_words,($first_zero+$$parameters{'distortion_limit'})-1);
		    $to_outer=min($f_no_words,$to_inner+$max_phrase_length);
		} else {
		    next if($prev_node_lpos<=0);
		    $from=$prev_node_lpos-1;
		    $to_inner=$first_zero-1;
		    $to_outer=$first_zero-1;
		}
	    }

	    my $left;
	    my $right;
	    my $direction_right=$direction eq 'right' ? 1 : 0;
	    
	    for(my $inner=$from; $inner!=$to_inner; $direction eq 'right' ? $inner++ : $inner--) {
		
		last if($direction eq 'right' && $to_inner<=$from);
		last if($direction eq 'left' && $to_inner>=$from);
		
		next if($prev_cover_vec[$inner]==1);
		
		if($direction eq 'right') {
		    $left=$inner;
		    $to_inner=$left+1 if($f_tokens->[$left]=~/^[\,\.\"\'\?\!\:]$/o);
		    $unweighted_distortion_costs=-1*abs(($prev_node_rpos+1)-$left);
		    
		} else {
		    $right=$inner;
		}
		
		my @cover_vec;
		@cover_vec=@prev_cover_vec if(!$rescore_mode);

		for(my $outer=$inner+$rescore_phrase_length; $outer!=$to_outer; $direction eq 'right' ? $outer++ : $outer--) {

		    last if(abs($outer-$inner)>=$max_phrase_length);
		    last if($prev_cover_vec[$outer]==1);
		    
		    if($direction eq 'right') {
			$right=$outer;
		    } else {
			$left=$outer;
			$unweighted_distortion_costs=-1*abs(($prev_node_rpos+1)-$left);		    
		    }

		    next if(($rescore_mode||$rescore_lattice) && ($left!=$rescore_l || $right!=$rescore_r));
		    next if(!defined($match_trans->[$left][$right]));
		    my $end_of_sentence=0;
		    
		    $f_phrase=join(' ',@$f_tokens[$left..$right]);
                    $unk_dm_next=1 if(!exists($lex_dm{$f_phrase}));

		    $f_no_words_next=$f_no_words_prev+($right-$left)+1;
		    if($f_no_words_next==$f_no_words) {
			$end_of_sentence=1;
			$unweighted_distortion_costs+=-1*abs(($right+1)-$f_no_words);
		    }
		    
		    my $orientation_index;
		    if($left==$prev_node_rpos+1) {
			$orientation_index=3;
		    } elsif($right==$prev_node_lpos-1) {
			$orientation_index=4;
		    } else {
			$orientation_index=5;
		    }
		    		    
		    my $end_orientation_index;
		    my $prev_end_orientation_index;
		    if($end_of_sentence) {
			if($right==$f_no_words-1) {
			    $end_orientation_index=3;
			    $prev_end_orientation_index=0;
			} else {
			    $end_orientation_index=5;
			    $prev_end_orientation_index=2;
			}
		    }
			
		    
		    my $cover_string='';
#		    my $lm_cached=0;
		    if($rescore_mode) {
			$$individual_costs{'distortion_cost'}+=$unweighted_distortion_costs;
			my $feature_name="lex_dm[$orientation_index]";

                        if($unk_dm_previous) {
                            $$individual_costs{$feature_name}+=$lex_dm{$unk_token}{$unk_token}[$orientation_index];
                        } else {
                            $$individual_costs{$feature_name}+=$lex_dm{$prev_f_phrase}{$prev_e_phrase}[$orientation_index];
                        }

#			$$individual_costs{$feature_name}+=$lex_dm{$prev_f_phrase}{$prev_e_phrase}[$orientation_index];
			if($end_of_sentence) {
			    $$individual_costs{$feature_name}+=$lex_dm{$end_sent_symbol}{$end_sent_symbol}[$prev_end_orientation_index];
			}
			$future_costs=0;		    
		    } else {
			for(my $k=$left; $k<=$right; $k++) {
			    $cover_vec[$k]=1;
			}		    
			$cover_string=&cover2char(\@cover_vec);

			$distortion_costs=$unweighted_distortion_costs*$distortion_weight;
                        if($unk_dm_previous) {
                            $distortion_costs+=$lex_dm{$unk_token}{$unk_token}[$orientation_index];
                        } else {
                            $distortion_costs+=$lex_dm{$prev_f_phrase}{$prev_e_phrase}[$orientation_index];
                        }

#			$distortion_costs+=$lex_dm{$prev_f_phrase}{$prev_e_phrase}[$orientation_index];

			$future_costs=&compute_future_costs(\@cover_vec,$future_cost_spans);
			$future_costs+=&min_jumps(\@cover_vec,$right)*$distortion_weight;

			if($end_of_sentence) {
			    $distortion_costs+=$lex_dm{$end_sent_symbol}{$end_sent_symbol}[$prev_end_orientation_index];			
			}
		    }
		    		    
#		foreach my $e_phrase (keys %{ $f2e_lex{$f_phrase} }) {
		    for(my $k=0; $k<@{ $match_trans->[$left][$right] }; $k++) {
			$e_phrase=$match_trans->[$left][$right][$k];

			my $costs=0;
			my $costs_nolm=0;
			my $lm_cached=0;
			my $lex_dm_costs=0;

			my $prev_orientation_index=$orientation_index-3;
			$unk_dm_next=1 if(!$unk_dm_next && !exists($lex_dm{$f_phrase}{$e_phrase}));

			if($rescore_lattice) {
			    next if($e_phrase ne $$lattice_translations{$current_node}{$next_node});
			}
			
			if($rescore_mode) {
#			next if($e_phrase ne $nbest_trans_map->[$left][$right]);
			    if($use_lm_cache && exists($$lm_cache{$prev_words_phrase}) && exists($$lm_cache{$prev_words_phrase}{$e_phrase})) {
				$lm_cached=1;
			    }
			    
			    my $feature_name="lex_dm[$prev_orientation_index]";
			    if($unk_dm_next) {
                                $$individual_costs{$feature_name}+=$lex_dm{$unk_token}{$unk_token}[$prev_orientation_index];
                            } else {
                                $$individual_costs{$feature_name}+=$lex_dm{$f_phrase}{$e_phrase}[$prev_orientation_index];
                            }

#			    $$individual_costs{$feature_name}+=$lex_dm{$f_phrase}{$e_phrase}[$prev_orientation_index];
			    if($end_of_sentence) {
				my $feature_name="lex_dm[$end_orientation_index]";
				if($unk_dm_next) {
                                    $$individual_costs{$feature_name}+=$lex_dm{$unk_token}{$unk_token}[$end_orientation_index];
                                } else {
                                    $$individual_costs{$feature_name}+=$lex_dm{$f_phrase}{$e_phrase}[$end_orientation_index];
                                }
#				$$individual_costs{$feature_name}+=$lex_dm{$f_phrase}{$e_phrase}[$end_orientation_index];
			    }								    
			} else {
			    $costs=$prev_node_costs+$f2e_lex{$f_phrase}{$e_phrase}+$distortion_costs;
#			    $lex_dm_costs=$lex_dm{$f_phrase}{$e_phrase}[$prev_orientation_index];
			    if($unk_dm_next) {
                                $lex_dm_costs=$lex_dm{$unk_token}{$unk_token}[$prev_orientation_index];
                            } else {
                                $lex_dm_costs=$lex_dm{$f_phrase}{$e_phrase}[$prev_orientation_index];
                            }
			    if($end_of_sentence) {
#				$lex_dm_costs+=$lex_dm{$f_phrase}{$e_phrase}[$end_orientation_index];
				if($unk_dm_next) {
                                    $lex_dm_costs+=$lex_dm{$unk_token}{$unk_token}[$end_orientation_index];
                                } else {
                                    $lex_dm_costs+=$lex_dm{$f_phrase}{$e_phrase}[$end_orientation_index];
                                }
			    }
			    $costs+=$lex_dm_costs;				

			    # CHECK IS THIS CORRECT?
			    if(0 && defined($max_in_stack->[$f_no_words_next])
			       && $costs+$future_costs<$max_in_stack->[$f_no_words_next]+$beam_width) {
				last;
			    }
			    if(0 && defined($min_in_full_stack->[$f_no_words_next])
			       && $costs+$future_costs<=$min_in_full_stack->[$f_no_words_next]) {
				last;
			    }
			    $e_phrase_prefix=$$e_phrase_prefixes{$e_phrase};
			}
			
			if($generate_rescore_lattice) {
			    $costs_nolm=$prev_node_costs+$f2e_lex_no_lm{$f_phrase}{$e_phrase}+$distortion_costs+$lex_dm_costs;
#			    print STDERR "costs_nolm=$costs_nolm\n";
			}

			my @e_phrase_words=split(/ /,$e_phrase);

			if($rescore_mode) {
			    $$individual_costs{'word_penalty'}+=-1*@e_phrase_words;

			    if(!defined($f2e_lex_features{$f_phrase}{$e_phrase})) {
				print STDERR "UNDEF: f2e_lex_features{$f_phrase}{$e_phrase}\n";
			    }

			    for(my $i=0; $i<@{ $f2e_lex_features{$f_phrase}{$e_phrase} }; $i++) {
				my $feature_name="phrase_table[$i]";
				$$individual_costs{$feature_name}+=$f2e_lex_features{$f_phrase}{$e_phrase}[$i];
			    }
			    if(!$lm_cached) {
				if(@e_phrase_words>=$lm_order) {
				    my @e_phrase_left=@e_phrase_words[0..($lm_order-2)];
				    my @e_phrase_right=@e_phrase_words[($lm_order-1)..(@e_phrase_words-1)];
				    if($use_lm_cache) {
					$$lm_cache{$prev_words_phrase}{$e_phrase}[0]=&lm_cost(\@e_phrase_left,\@e_phrase_right,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs);
				    } else {
					$costs+=&lm_cost(\@e_phrase_left,\@e_phrase_right,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs);
				    }
#				    print STDERR "caching: lm_cache{$prev_words_phrase}{$e_phrase}[0]=$$lm_cache{$prev_words_phrase}{$e_phrase}[0]\n";
#				$costs+=&lm_cost(\@e_phrase_left,\@e_phrase_right,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs);
				}
				if($use_lm_cache) {
				    $$lm_cache{$prev_words_phrase}{$e_phrase}[1]=&lm_cost_between(\@prev_e_words,\@e_phrase_words,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs);
				} else {
				    $costs+=&lm_cost_between(\@prev_e_words,\@e_phrase_words,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs);
				}
#				print STDERR "caching: lm_cache{$prev_words_phrase}{$e_phrase}[1]=$$lm_cache{$prev_words_phrase}{$e_phrase}[1]\n";
#			    $costs+=&lm_cost_between(\@prev_e_words,\@e_phrase_words,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs);
				
			    } else {
				if(@e_phrase_words>=$lm_order) {
				    $$individual_costs{'lm_weight'}+=$$lm_cache{$prev_words_phrase}{$e_phrase}[0];
				}
#				$$individual_costs{'lm_weight_between'}+=$$lm_cache{$prev_words_phrase}{$e_phrase}[1];
				$$individual_costs{'lm_weight'}+=$$lm_cache{$prev_words_phrase}{$e_phrase}[1];
				
			    }
			} else {
			    if($use_lm_cache && (!exists($$lm_between_cache{$prev_words_phrase})||!exists($$lm_between_cache{$prev_words_phrase}{$e_phrase_prefix}))) {
				$$lm_between_cache{$prev_words_phrase}{$e_phrase_prefix}=&lm_cost_between(\@prev_e_words,\@e_phrase_words,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs);
			    }
			    if($use_lm_cache) {
				$costs+=$$lm_between_cache{$prev_words_phrase}{$e_phrase_prefix};
			    } else {
				$costs+=&lm_cost_between(\@prev_e_words,\@e_phrase_words,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs);
			    }
			}
			
			if($end_of_sentence) {
			    unshift(@e_phrase_words,$prev_e_words[-1]) if(@e_phrase_words==1);
			    $costs+=&lm_cost_between(\@e_phrase_words,\@end_of_sentence_marker,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs);
			}
			
			if(!$rescore_mode) {
			    if(!defined($max_in_stack->[$f_no_words_next])) {
				$max_in_stack->[$f_no_words_next]=$costs+$future_costs;
			    } elsif($costs+$future_costs+$beam_width>$max_in_stack->[$f_no_words_next]) {
				undef @{ $stack->[$f_no_words_next] };
				$max_in_stack->[$f_no_words_next]=$costs+$future_costs;
			    } elsif($costs+$future_costs>$max_in_stack->[$f_no_words_next]) {
				$max_in_stack->[$f_no_words_next]=$costs+$future_costs;
			    } else {
				if(defined($max_in_stack->[$f_no_words_next])
				   && $costs+$future_costs<$max_in_stack->[$f_no_words_next]+$beam_width) {
				    next;
				}
				if(defined($min_in_full_stack->[$f_no_words_next])
				   && $costs+$future_costs<=$min_in_full_stack->[$f_no_words_next]) {
				    next;
				} 
				if($costs+$future_costs>=$favorite_child_cost) {
				    $favorite_child_cost=$costs+$future_costs;
				} elsif(0 && $favorite_child_cost+$children_beam_width>=$costs+$future_costs) {
				    next;
				}
				
#			    if(defined($next_total_cost) && $costs+$future_costs<$next_total_cost) {
#				next;
#			    }			    
			    }
			}
			
			my $no_last_words=0;
			my @last_words;
			for(my $i=@e_phrase_words-1; $i>=0 && $no_last_words<$suffix_length; $i--) {
			    unshift(@last_words,$e_phrase_words[$i]);
			    $no_last_words++;
			}
			for(my $i=@prev_e_words-1; $i>=0 && $no_last_words<$suffix_length; $i--) {
			    unshift(@last_words,$prev_e_words[$i]);
			    $no_last_words++;
			}
			
			if(0) {
			my @last_words;
			for(my $i=@e_phrase_words-1; $i>=0 && $i>=@e_phrase_words-$suffix_length; $i--) {
			    unshift(@last_words,$e_phrase_words[$i]);
#			    if(@e_phrase_words==1) {
#				$last_w_string=join(' ',@last_words);
#			    }
			}
			if(@e_phrase_words==1) {
			    my $last_w_string=join(' ',@last_words);
			    print STDERR "1: last_w_string=$last_w_string\n";
			    my $prev_w_string=join(' ',@prev_e_words);
			    print STDERR "1: prev_w_string=$prev_w_string\n";			   
			}

			for(my $i=$suffix_length-@e_phrase_words, my $j=@prev_e_words-1; $i>0; $i--, $j--) {
			    unshift(@last_words,$prev_e_words[$j]);			    
			}
			if(@e_phrase_words==1) {
			    my $last_w_string=join(' ',@last_words);
			    print STDERR "2: last_w_string=$last_w_string\n";
			    my $prev_w_string=join(' ',@prev_e_words);
			    print STDERR "2: prev_w_string=$prev_w_string\n";			   
			}
			}
			
			$$node_id++;
			
			$nodes_back->[$$node_id]=$prev_node_id;
			$nodes_tr->[$$node_id]=$e_phrase;
			$nodes_cos->[$$node_id]=$costs;
			$nodes_cos_nolm->[$$node_id]=$costs_nolm if($generate_rescore_lattice);
#			print STDERR "nodes_cos_nolm->[$$node_id]=$nodes_cos_nolm->[$$node_id]\n";
			$nodes_lpos->[$$node_id]=$left;
			$nodes_rpos->[$$node_id]=$right;
			$nodes_cov->[$$node_id]=$cover_string;
			$nodes_tc->[$$node_id]=$costs+$future_costs;
			@{ $nodes_last->[$$node_id] }=@last_words;
			$nodes_label->[$$node_id]=$next_node if($rescore_lattice);		       
			push(@{ $stack->[$f_no_words_next] },$$node_id);

			last if($rescore_mode||$rescore_lattice);

#		    $child++;
#		    last if($child>=$max_no_children);

		    }		
		}
	    }       
	}

	last if(!$rescore_lattice);

    }

    $nodes_favorite_child_cost->[$prev_node_id]=$favorite_child_cost; # if($favorite_child_cost>-99999);
}    

	


sub within_beam {
    my($total_costs,$max_in_stack,$min_in_full_stack,$f_no_words_next,$beam_width)=@_;

    if(defined($max_in_stack->[$f_no_words_next])
       && $total_costs<$max_in_stack->[$f_no_words_next]+$beam_width) {
	return 0;
    } 

    if(defined($min_in_full_stack->[$f_no_words_next])
       && $total_costs<=$min_in_full_stack->[$f_no_words_next]) {
#	print STDERR "total_costs=$total_costs<=min_in_full_stack->[$f_no_words_next]=$min_in_full_stack->[$f_no_words_next]\n";
	return 0;
    }

    return 1;
    
}

sub last_n_words {
    my($n,$i,$j,$prev,$phrase,@last_words);
    undef @last_words;
    ($n,$prev,$phrase)=@_;
    for($i=@$phrase-1; $i>=0 && $i>=@$phrase-$n; $i--) {
        unshift(@last_words,$phrase->[$i]);
    };
    for($i=$n-@$phrase, $j=@$prev-1; $i>0; $i--, $j--) {
	unshift(@last_words,$prev->[$j]);
    }
	
    return @last_words;
}

return 1;

