
sub find_matching_patterns {

    my($f_tokens,$f2e_pattern_lex,$f2e_pattern_lm_top,$parameters,$match_trans,$rescore_mode,$nbest_sent,$nbest_trans_map,$translation_order)=@_;

    my $unknown_word_trans_prob=$$parameters{'unknown_word_trans_prob'};
    my $max_phrase_length=$$parameters{'max_phrase_length'};
    my $max_hole_length=$$parameters{'max_hole_length'};
    my $no_punct_in_holes=1;

    my $last_f_token_index=@$f_tokens-1;

    if($rescore_mode) {
	my $coverset_string;
	($coverset_string)=$$nbest_sent=~/ coversets=([0-9].*)$/o;
	my @covers=split(/\|\|\|/,$coverset_string);
	for(my $i=0; $i<@covers; $i++) {
	    my($l,$r,$e_phrase)=$covers[$i]=~/^([0-9]+):([0-9]+) (.*)$/o;
#	    $nbest_trans_map->[$l][$r]=$e_phrase;
	    push(@$translation_order,"$l $r");
	    push(@{ $match_trans->[$l][$r] },$e_phrase);
	}
    } else {

	for(my $i1=0; $i1<@$f_tokens; $i1++) {
	    for(my $i2=$i1; $i2<@$f_tokens; $i2++) {
		my $f_i=join(" ",@$f_tokens[$i1..$i2]);
		
		next if($f_i=~/[\,\.\!\"\:\;]/o);
		
		my @f_patterns;
		if($i1>0 && $i2<$last_f_token_index) {
		    @f_patterns=("X1 $f_i", "$f_i X1", "X1 $f_i X2", "X2 $f_i X1" );
		} elsif($i1>0) {
		    @f_patterns=("X1 $f_i");
		} elsif($i2<$last_f_token_index) {
		    @f_patterns=("$f_i X1");
		} else {
		    next;
		}
		
		my $pattern_cov_string='1' x (($i2-$i1)+1);
		
		foreach my $f_pattern (@f_patterns) {
		    
		    next if(!(exists($f2e_pattern_lm_top{$f_pattern})));
		    my $f_constraints;
		    my $holes;		
		    if($f_pattern=~/^X[0-9] .+ X[0-9]$/o) {
			for(my $i=$i1-1; $i>=0 && $i>=($i1-$max_hole_length); $i--) {			
			    if($no_punct_in_holes && $tokens->[$i]=~/^[\,\.\!\"\:\;]$/o) {
				last;
			    }
			    for(my $j=$i2+1; $j<@$tokens && $j<=$i2+$max_hole_length; $j++) {
				if($no_punct_in_holes && $tokens->[$j]=~/^[\,\.\!\"\:\;]$/) {
				    last;
				}						    
				$holes="$i-" .($i1-1) . " " . ($i2+1) . "-$j"; 
				if(!defined($m_patterns[$i][$j]{$holes})) {
				    $m_patterns[$i][$j]{$holes}=-9999;
				}
				if($f2e_pattern_lm_top{$f_pattern}>$m_patterns[$i][$j]{$holes}) {
				    $m_patterns[$i][$j]{$holes}=$f2e_pattern_lm_top{$f_pattern};
				}
			    }
			}
			if($f_pattern=~/^X1 .+ X2$/o) {
			    $f_constraints="I-" . ($i1-1) . " " . ($i2+1) . "-I";
			} elsif($f_pattern=~/^X2 .+ X1$/o) {
			    $f_constraints=($i2+1) . "-I I-" . ($i1-1); 
			}
			
		    } elsif($f_pattern=~/^X[0-9] .+/o) {
			for(my $i=$i1-1; $i>=0 && $i>=($i1-$max_hole_length); $i--) {
			    if($no_punct_in_holes && $f_tokens->[$i]=~/^[\,\.\!\"\:\;]$/o) {
				last;
			    }			
			    $holes="$i-" .($i1-1);
			    if(!defined($m_patterns[$i][$i2]{$holes})) {
				$m_patterns[$i][$i2]{$holes}=-9999;
			    }
			    if($f2e_pattern_lm_top{$f_pattern}>$m_patterns[$i][$i2]{$holes}) {
				$m_patterns[$i][$i2]{$holes}=$f2e_pattern_lm_top{$f_pattern};
			    }
			}
			$f_constraints="I-" . ($i1-1);
			
		    } elsif($f_pattern=~/^.+ X[0-9]$/o) {
			for(my $j=$i2+1; $j<@tokens && $j<=$i2+$max_hole_length; $j++) {
			    if($no_punct_in_holes && $tokens[$j]=~/^[\,\.\!\"\:\;]$/o) {
				last;
			    }						    
			    $holes=($i2+1) . "-$j";
			    if(!defined($m_patterns[$i1][$j]{$holes})) {
				$m_patterns[$i1][$j]{$holes}=-9999;
			    }
			    if($f2e_pattern_lm_top{$f_pattern}>$m_patterns[$i1][$j]{$holes}) {
				$m_patterns[$i1][$j]{$holes}=$f2e_pattern_lm_top{$f_pattern};
#			    print STDERR "m_patterns[$i1][$j]{$holes}=$m_patterns[$i1][$j]{$holes}\n";
			    }
			}	
			$f_constraints=($i2+1) . "-I";
			
		    }
		    
		    
#		print STDERR "f_pattern=$f_pattern\n";
		    foreach my $e_pattern (keys %{ $f2e_pattern_lex{$f_pattern} }) {
#		    print STDERR "  e_pattern=$e_pattern\n";
#		    print STDERR "  1 generate_constraints($f_constraints,$e_pattern)\n";
			$match_patterns[$i1][$i2]{$f_pattern}{$e_pattern}=generate_constraints($f_constraints,$f_pattern,$e_pattern,$i1,$i2) . ":$pattern_cov_string";
			
#		    print STDERR "f_constraints=$f_constraints\n";
			
#		    print STDERR "  constraints=$match_patterns[$i1][$i2]{$f_pattern}{$e_pattern}\n";
		    }		
		}
		
		
		for(my $j1=$i2+2; $j1<@$f_tokens; $j1++) {
		    if($no_punct_in_holes && $f_tokens->[$j1-1]=~/^[\,\.\!\"\:\;]$/o) {
			last;
		    }						    
		    
		    for(my $j2=$j1; $j2<@$f_tokens; $j2++) {
			$f_j=join(" ",@$f_tokens[$j1..$j2]);
			
			next if($f_j=~/[\,\.\!\"\:\;]/o);
			
			my @f_patterns;
			if($i1>0 && $i2<$last_f_token_index) {
			    @f_patterns=("X1 $f_i X2 $f_j", "X2 $f_i X1 $f_j", "$f_i X1 $f_j X2", "$f_i X2 $f_j X1");
			} elsif($i1>0) {
			    @f_patterns=("X1 $f_i X2 $f_j", "X2 $f_i X1 $f_j");
			} elsif($i2<$last_f_token_index) {
			    @f_patterns=("$f_i X1 $f_j X2", "$f_i X2 $f_j X1");
			} else {
#			next;
			}
			push(@f_patterns,"$f_i X1 $f_j");
			
			my $pattern_cov_string="";
			for($l=$i1; $l<=$j2; $l++) {
			    if(($i1<=$l && $l<=$i2) || ($j1<=$l && $l<=$j2)) {
				$pattern_cov_string.='1';
			    } else {
				$pattern_cov_string.='0';
			    }
			}
			
			
			foreach my $f_pattern (@f_patterns) {
			    
			    next if(!(exists($f2e_pattern_lm_top{$f_pattern})));
			    
			    if($f_pattern=~/^X[0-9] .+ X[0-9] .+$/o) {
				for(my $i=$i1-1; $i>=0 && $i>=($i1-$max_hole_length); $i--) {			
				    $holes="$i-" . ($i1-1) . " " . ($i2+1) . "-" .($j1-1); 
				    
				    if(!defined($m_patterns[$i][$j2]{$holes})) {
					$m_patterns[$i][$j2]{$holes}=-9999;
				    }
				    if($f2e_pattern_lm_top{$f_pattern}>$m_patterns[$i][$j2]{$holes}) {
					$m_patterns[$i][$j2]{$holes}=$f2e_pattern_lm_top{$f_pattern};
				    }
				}
				if($f_pattern=~/^X1 .+ X2 /o) {
				    $f_constraints="I-" . ($i1-1) . " " . ($i2+1) . "-" . ($j1-1);
				} elsif($f_pattern=~/^X2 .+ X1 /o) {
				    $f_constraints=($i2+1) . "-" . ($j1-1) . " I-" . ($i1-1);
				}
			    } elsif($f_pattern=~/.+ X[0-9] .+ X[0-9]$/o) {
				for(my $j=$j2+1; $j<@$f_tokens && $j<=$j2+$max_hole_length; $j++) {
				    $holes=($i2+1) . "-"  . ($j1-1) . " " . ($j2+1) . "-$j";
				    if(!defined($m_patterns[$i1][$j]{$holes})) {
					$m_patterns[$i1][$j]{$holes}=-9999;
				    }
				    if($f2e_pattern_lm_top{$f_pattern}>$m_patterns[$i1][$j]{$holes}) {
					$m_patterns[$i1][$j]{$holes}=$f2e_pattern_lm_top{$f_pattern};
				    }
				}
				if($f_pattern=~/ X1 .+ X2$/o) {
				    $f_constraints=($i2+1) . "-" . ($j1-1) . " " . ($j2+1) . "-I";
				} elsif($f_pattern=~/ X2 .+ X1$/o) {
				    $f_constraints=($j2+1) . "-I " . ($i2+1) . "-" . ($j1-1);
				}
				
			    } elsif($f_pattern=~/.+ X[0-9] .+/o) {
				next if(!(exists($f2e_pattern_lm_top{$f_pattern})));
				
				$holes=($i2+1) . "-"  . ($j1-1);
				if(!defined($m_patterns[$i1][$j2]{$holes})) {
				    $m_patterns[$i1][$j2]{$holes}=-9999;
				}
				if($f2e_pattern_lm_top{$f_pattern}>$m_patterns[$i1][$j2]{$holes}) {
				    $m_patterns[$i1][$j2]{$holes}=$f2e_pattern_lm_top{$f_pattern};
				}
				$f_constraints=($i2+1) . "-" . ($j1-1);
			    } 
			    
			    foreach my $e_pattern (keys %{ $f2e_pattern_lex{$f_pattern} }) {
#			    print STDERR "  2 generate_constraints($f_constraints,$e_pattern)\n";
				$match_patterns[$i1][$j2]{$f_pattern}{$e_pattern}=generate_constraints($f_constraints,$f_pattern,$e_pattern,$i1,$j2) . ":$pattern_cov_string";
#			    print STDERR "f_constraints=$f_constraints\n";
				
			    }		
			}
			
			
			for(my $k1=$j2+2; $k1<@$f_tokens; $k1++) {
			    if($no_punct_in_holes && $f_tokens->[$k1-1]=~/^[\,\.\!\"\:\;]$/o) {
				last;
			    }						    
			    
			    for($k2=$k1; $k2<@$f_tokens; $k2++) {
				$f_k=join(" ",@$f_tokens[$k1..$k2]);
				
				next if($f_k=~/[\,\.\!\"\:\;]/o);
				
				my @f_patterns=("$f_i X1 $f_j X2 $f_k", "$f_i X2 $f_j X1 $f_k");
				
				my $pattern_cov_string="";
				for($l=$i1; $l<=$k2; $l++) {
				    if(($i1<=$l && $l<=$i2) || ($j1<=$l && $l<=$j2) || ($k1<=$l && $l<=$k2)) {
					$pattern_cov_string.='1';
				    } else {
					$pattern_cov_string.='0';
				    }
				}
				
				foreach my $f_pattern (@f_patterns) {
				    
				    next if(!(exists($f2e_pattern_lm_top{$f_pattern})));
				    
				    my $holes=($i2+1) . "-"  . ($j1-1) . " " . ($j2+1) . "-" . ($k1-1);
				    if(!defined($m_patterns[$i1][$k2]{$holes})) {
					$m_patterns[$i1][$k2]{$holes}=-9999;
				    }
				    if($f2e_pattern_lm_top{$f_pattern}>$m_patterns[$i1][$k2]{$holes}) {
					$m_patterns[$i1][$k2]{$holes}=$f2e_pattern_lm_top{$f_pattern};
				    }
				    
				    if($f_pattern=~/.+ X1 .+ X2 /o) {
					$f_constraints=($i2+1) . "-" . ($j1-1) . " " . ($j2+1) . "-" . ($k1-1);
				    } elsif($f_pattern=~/.+ X2 .+ X1 /o) {
					$f_constraints=($j2+1) . "-" . ($k1-1) . " " . ($i2+1) . "-" . ($j1-1);
				    }
				    
				    foreach my $e_pattern (keys %{ $f2e_pattern_lex{$f_pattern} }) {
#				    print STDERR "  3 generate_constraints($f_constraints,$e_pattern)\n";
#orig:
#				    $match_patterns[$i1][$k2]{$f_pattern}{$e_pattern}=generate_constraints($f_constraints,$e_pattern) . ":$pattern_cov_string";
					
					$match_patterns[$i1][$k2]{$f_pattern}{$e_pattern}=generate_constraints($f_constraints,$f_pattern,$e_pattern,$i1,$k2) . ":$pattern_cov_string";
				    }					       
				}
			    }
			}
		    }
		}
	    }
	}
    }
}

return 1;
