
sub initialize_future_cost_spans {

    my($f_tokens,$match_trans,$future_cost_spans,$parameters)=@_;
    
    my $max_phrase_length=$$parameters{'max_phrase_length'};
    my($f_phrase,$prob);
 
    for(my $length=0; $length<@$f_tokens; $length++) {
	for(my $i=0; $i<@$f_tokens-$length; $i++) {
	    my $j=$i+$length;

	    if($length<$max_phrase_length) {
		$f_phrase=join(" ",@$f_tokens[$i..$j]);
		if(exists($f2e_lex_top_lm{$f_phrase})) {
		    $future_cost_spans->[$i][$j]=$f2e_lex_top_lm{$f_phrase};
		} else {
		    $future_cost_spans->[$i][$j]=-9999;
		}
	    } else {
		$future_cost_spans->[$i][$j]=-9999;		
	    }

	    for(my $k=$i; $k<$j; $k++) {
		$prob=$future_cost_spans->[$i][$k]+$future_cost_spans->[$k+1][$j];
		if($future_cost_spans->[$i][$j]<$prob) {
		    $future_cost_spans->[$i][$j]=$prob;
		}
	    }
	}
    }
}

sub compute_future_costs {
    my($j,$costs,$open_left,$open_right,$cover_vec);
    ($cover_vec,$future_cost_spans)=@_;
    $costs=0;
    for(my $i=0; $i<@$cover_vec; $i++) {
        next if($cover_vec->[$i]==1);
        $open_left=$i;
        undef $open_right;
        for($j=$i; $j<@$cover_vec && $cover_vec->[$j]==0; $j++) {
            $open_right=$j;
        }
        
        if(defined($open_right)) {
            $costs+=$future_cost_spans->[$open_left][$open_right];
        }
        $i=$j;
    }

    return $costs;
}


sub min_jumps {
    my($cover_vec,$i,$j,$cost,$first_zero);
    ($cover_vec,$j)=@_;

    $first_zero=@$cover_vec;

    for($i=0; $i<@$cover_vec; $i++) {
        if($cover_vec->[$i]==0) {
            $first_zero=$i;
            last;
        };
    };

    if($first_zero==@$cover_vec) {
        return 0;
    };
    
    $cost=abs(($j+1)-$first_zero);

    for($i=$first_zero+1; $i<@$cover_vec; $i++) {
       if($cover_vec->[$i]==1) {
           $cost++;
       };
   };

    return -1 * $cost;
}


return 1;

