

sub compute_highest_lm_probs {
    my($lm_file,$max_lm_prob_file,$features,$max_lm_prob)=@_;

    my $lm_weight=$$features{'lm_weight'};

    if(!(-e "$max_lm_prob_file") || (-z "$max_lm_prob_file")) {
    
	my $line;
	print STDERR "Reading in $lm_file ... ";
	open(F,"<$lm_file")||die("can't open file $lm_file: $!\n");
	while(defined($line=<F>) && $line!~/^\\1-grams:/) {
	}
	
	my $max_bow=-1*10**10;
	my $ngram=1;
	while(defined($line=<F>)) {
	    if($line=~/^\\([0-9]+)\-grams:[\s\t]*\n/) {
		$ngram=$1;
		next;
	    }
	    next if($line=~/^[\s\t]*\n/);
	    next if($line=~/^\\end\\[\s\t]*\n/);

	    chomp($line);
	    my($prob,$ngram_string,$bow)=split(/\t/,$line);
	    
	    if(defined($bow) && $bow>$max_bow) {
		$max_bow=$bow;
	    }
	    if($ngram==1) {
		$$max_lm_prob{$ngram_string}=$prob;
	    } else {
		my @words=split(/ +/,$ngram_string);
		if(!defined($words[-1])) {
#		    print STDERR "ngram_string=$ngram_string words[-1]=$words[-1]\n";
		}
		if(!(defined($$max_lm_prob{$words[-1]}))
		   || $$max_lm_prob{$words[-1]}<$prob) {
#		    print STDERR "$line\n";
#		    print STDERR "max_lm_prob{$words[-1]}=$$max_lm_prob{$words[-1]}<$prob\n";
		    $$max_lm_prob{$words[-1]}=$prob;
		}		
	    }
	}
	close(F);
	print STDERR "done.\n";

	print STDERR "Writing max_lm_prob_file \'$max_lm_prob_file\' ... ";
	open(MX,">$max_lm_prob_file") || die("can't open file $max_lm_prob_file: $!\n");
	foreach my $word (keys %$max_lm_prob) {
#	    printf MX "$word\t%.6f\n", log(10**$$max_lm_prob{$word});
	    print MX "$word\t", log(10**$$max_lm_prob{$word}), "\n";
#	    print MX "$word\t", $$max_lm_prob{$word}, "\n";
	}
	close(MX);
	print STDERR "done.\n";
    };
    undef $max_prob_lm;

    print STDERR "Reading max_lm_prob_file \'$max_lm_prob_file\' ... ";
    open(MX,"<$max_lm_prob_file");
    while(defined(my $line=<MX>)) {
	chomp($line);
	my($word,$prob)=split(/\t/,$line);	
	$$max_lm_prob{$word}=$prob*$lm_weight;
    }
    close(MX);
    print STDERR "done.\n";

}

return 1;
