

sub lm_cost {
    my($words_left,$words_right,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs)=@_;
    my $cap=$parameters->{'lm_cap'};
    my $lm_order=$parameters->{'lm_order'};
    my $lm_string;
    my $total=0;

    my $lm_weight=$$features{'lm_weight'};

    for(my $lm_index=0; $lm_index<@$lm_srilm_ids; $lm_index++) {
	my $lm_srilm_id=$lm_srilm_ids->[$lm_index];
	
	my $sum=0; 

	if(@$words_right==0) {
	    $sum+=&lm_ngram_prob($lm_srilm_id,$words_left,$cap,$parameters);
	} else {
	    if($lm_order==3) {
		if(@$words_left==1) {
		    $lm_string=$words_left->[-1] . ' ' . $words_right->[0];
		    $sum+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
		} else {
		    $lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		    $sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}

		if(@$words_right>1) {
		    $lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
		    $sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
		
		for($i=2; $i<@$words_right; $i++) {
		    $lm_string=$words_right->[$i-2] . ' ' . $words_right->[$i-1] . ' ' . $words_right->[$i];
		    $sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
	    } elsif($lm_order==4) {
		if(@$words_left==1) {
		    # l[-1] || r[0] :: p(r[0] | l[-1])
		    $lm_string=$words_left->[-1] . ' ' . $words_right->[0];
		    $sum+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
		    if(@$words_right>=2) {
			# l[-1] || r[0] r[1] :: p(r[1] | l[-1] r[0])
			$lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
			$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		    }
		} elsif(@$words_left==2) {
		    # l[-2] l[-1] || r[0] :: p(r[0] | l[-2] l[-1])
		    $lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		    $sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		    if(@$words_right>=2) {
			# w w | w w  :: p(r[1] | l[-2] l[-1] r[0])
			$lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
			$sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		    }
		} else {
		    # w w w | w
		    $lm_string=$words_left->[-3] . ' ' . $words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		    $sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		    my $debug_prob=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		    print STDERR "lm_cost:get4gramProb_LM(lm_srilm_id,$lm_string,$cap)=$debug_prob\n";
		    if(@$words_right>=2) {
			# w w | w w
			$lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
			$sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		    }
		}
		
		if(@$words_right>2) {
		    # w | w w w
		    $lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1] . ' ' . $words_right->[2];
		    $sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
		    
		for(my $i=3; $i<@$words_right; $i++) {
		    $lm_string=$words_right->[$i-3] . ' ' . $words_right->[$i-2] . ' ' . $words_right->[$i-1] . ' ' . $words_right->[$i];
		    $sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
	    }
	}

	if($rescore_mode) {
	    $$individual_costs{'lm_weight'}+=$sum;
	    $total+=$sum;
	} else {
	    $total+=$sum*$lm_weight;
	}

#	$$individual_costs{'lm_weight'}+=$sum if($rescore_mode);
#	$total+=$sum*$lm_weight;

    }




#	my $l=join(" ",@$words_left);
#	my $r=join(" ",@$words_right);
#	print STDERR "p($l :: $r)=";
#	print STDERR "$total\n";
    	
    return $total;    
}


sub lm_cost_between {
    my($words_left,$words_right,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs)=@_;
    my $cap=$parameters->{'lm_cap'};
    my $lm_order=$parameters->{'lm_order'};
    my $lm_string;
    my $total=0;

#    my $lm_weight=$$features{'lm_weight_between'};
    my $lm_weight=$$features{'lm_weight'};

    for(my $lm_index=0; $lm_index<@$lm_srilm_ids; $lm_index++) {
	my $lm_srilm_id=$lm_srilm_ids->[$lm_index];
	
	my $sum=0; 

	if($lm_order==3) {
	    if(@$words_left==1) {
		$lm_string=$words_left->[-1] . ' ' . $words_right->[0];
		$sum+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    } else {
		$lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    }
	    
	    if(@$words_right>1) {
		$lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    }	
	} elsif($lm_order==4) {
	    if(@$words_left==1) {
		# w | w
		$lm_string=$words_left->[-1] . ' ' . $words_right->[0];
		$sum+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
		if(@$words_right>=2) {
		    # w | w w
		    $lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
		    $sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
	    } elsif(@$words_left==2) {
		# w w | w
		$lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		my $debug_prob=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		print STDERR "lm_cost_between:get3gramProb_LM(lm_srilm_id,$lm_string,$cap)=$debug_prob\n";
		if(@$words_right>=2) {
		    # w w | w w
		    $lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
		    $sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
	    } else {
		# w w w | w
		$lm_string=$words_left->[-3] . ' ' . $words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		$sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		if(@$words_right>=2) {
		    # w w | w w
		    $lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
		    $sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		    my $debug_prob=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		    print STDERR "lm_cost_between:get4gramProb_LM(lm_srilm_id,$lm_string,$cap)=$debug_prob\n";

		}
	    }

#	    if(@$words_left>1 && @$words_right>1) {
#		$lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
#		$sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
#	    }

	    if(@$words_right>2) {
		# w | w w w
		$lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1] . ' ' . $words_right->[2];
		$sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    }			   
	}
    
#        $$individual_costs{'lm_weight_between'}+=$sum if($rescore_mode);
        $$individual_costs{'lm_weight'}+=$sum if($rescore_mode);
       
	$total+=$sum;
    }
    
#    my $l=join(" ",@$words_left);
#    my $r=join(" ",@$words_right);
#    print STDERR " p($l :: $r)=";
#    print STDERR "$total\n";

    if($rescore_mode) {
    } else {
	$total*=$lm_weight;
    }

    return $total;
}




sub lm_cost_thread {
    my($words_left,$words_right,$lm_id)=@_;
    my $cap=0;
    my $lm_string;
    my $total=0;
    my $lm_weight=1;

    print STDERR "foo\n";
    my $l=join(" ",@$words_left);
    my $r=join(" ",@$words_right);
    print STDERR "p($l :: $r)=\n";

#    for(my $lm_index=0; $lm_index<@lm_srilm_ids; $lm_index++) {
#	my $lm_srilm_id=$lm_srilm_ids[$lm_index];
		
	my $sum=0; 

	if(@$words_right==0) {
	    $sum+=&lm_ngram_prob($lm_srilm_id,$words_left,$cap);
	} else {
	    $lm_string=$words_left->[-1] . " " . $words_right->[0];
	    print STDERR "2gram\n";
	    $sum+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    if(@$words_left>1) {
		$lm_string=$words_left->[-2] . " " . $words_left->[-1] . " " . $words_right->[0];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    }
	    if(@$words_right>1) {
		$lm_string=$words_left->[-1] . " " . $words_right->[0] . " " . $words_right->[1];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    }
	
	    for($i=2; $i<@$words_right; $i++) {
		$lm_string=$words_right->[$i-2] . " " . $words_right->[$i-1] . " " . $words_right->[$i];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    };
#	}

	$total+=$sum*$lm_weight;

	my $l=join(" ",@$words_left);
	my $r=join(" ",@$words_right);
	print STDERR "p($l :: $r)=";
	print STDERR "$total\n";
	
	return $total;
    }
}


sub lm_ngram_prob {
    my($words,$lm_srilm_id);
    ($lm_srilm_id,$words,$cap,$parameters)=@_;

    my $lm_order=$parameters->{'lm_order'};

    my $lm_string;
    my $total=0;

    if(defined($words->[0]) && $words->[0] ne '<s>') {
	$total+=srilm::get1gramProb_LM($lm_srilm_id,$words->[0],$cap);
    }
    if(defined($words->[1])) {
	$lm_string=$words->[0] . ' ' . $words->[1];
	$total+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
    }
    
    if($lm_order==3) {
	for(my $i=2; $i<@$words; $i++) {
	    $lm_string=$words->[$i-2] . ' ' . $words->[$i-1] . ' ' . $words->[$i];
	    $total+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	}
    } elsif($lm_order==4) {
	if(defined($words->[2])) {
	    $lm_string=$words->[0] . ' ' . $words->[1] . ' ' . $words->[2];
	    $total+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	}
	for(my $i=3; $i<@$words; $i++) {
	    $lm_string=$words->[$i-3] . ' ' . $words->[$i-2] . ' ' . $words->[$i-1] . ' ' . $words->[$i];
	    $total+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
	}       
    }

    return $total;
}




return 1;
