
sub load_local_lm_file {    
    my($lm_file,$lm_order,$no_lms,$lm_vocab_ids)=@_;

    print STDERR "Reading in LM file \'$lm_file\' (order=$lm_order) ... ";
    my $time_begin=time;
    if($lm_file=~/\.gz$/o) {
        open LM, "<:gzip", $lm_file, or die("can't open $lm_file: $!\n");
    } else {
        open(LM,"<$lm_file") || die("can't open $lm_file: $!\n");
    }
    while(defined(my $line=<LM>)) {
	if($line=~/lm word\_pos=\"(.+)\" order=[0-9]+>/) {
	    my $word_pos=$1;
	    if(defined($$lm_vocab_ids{$word_pos})) {
		my $tmp_file="tmp.$$.lm";
		my $current_n=0;
		print STDERR "local lm match: $word_pos\n";
		open(TMP,">$tmp_file")||die("can't open $tmp_file: $!\n");
		while(defined($line=<LM>) && $line!~/^<\/lm>/) {
		    if($line=~/^\\([0-9]+)-grams:/) {
			$current_n=$1;
		    }

		    if(0 && $current_n<$lm_order && $line=~/^([^\s\t]+)(\t.*\n)$/o) {
			my $prob=$1;
			my $rest=$2;
			$prob+=-99;
#			print STDERR "line=$line";
#			print STDERR "new=",$prob, $rest;
			print TMP $prob, $rest;
		    } else {
			print TMP $line;
		    }
		}
		close(TMP);
		
		my $lm_srilm_id;
		if($no_lms==0) {
		    $lm_srilm_id=srilm::init_LM($lm_order);
		} else {
		    $lm_srilm_id=srilm::add_LM($lm_order);
		}
		srilm::readFile_LM($lm_srilm_id,$tmp_file);
		unlink("$tmp_file");
		$$lm_vocab_ids{$word_pos}=$lm_srilm_id;
		$no_lms++;
	    } else {
		while(defined($line=<LM>) && $line!~/^<\/lm>/) {
		}
	    }
	}
    }
    my $time_end=time;
    printf STDERR "done. (%.2f sec)\n", $time_end-$time_begin;

}




return 1;


