

sub lm_cost {
    my($words_left,$words_right,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs)=@_;
    my $cap=$parameters->{'lm_cap'};
    my $lm_order=$parameters->{'lm_order'};
    my $lm_string;
    my $total=0;

    my $lm_weight=$$features{'lm_weight'};

    for(my $lm_index=0; $lm_index<@$lm_srilm_ids; $lm_index++) {
	my $lm_srilm_id=$lm_srilm_ids->[$lm_index];
	
	my $sum=0; 

	if(@$words_right==0) {
	    $sum+=&lm_ngram_prob($lm_srilm_id,$words_left,$cap,$parameters);
	} else {
	    if($lm_order==3) {
		if(@$words_left==1) {
		    $lm_string=$words_left->[-1] . ' ' . $words_right->[0];
		    $sum+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
		} else {
		    $lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		    $sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}

		if(@$words_right>1) {
		    $lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
		    $sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
		
		for($i=2; $i<@$words_right; $i++) {
		    $lm_string=$words_right->[$i-2] . ' ' . $words_right->[$i-1] . ' ' . $words_right->[$i];
		    $sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
	    } elsif($lm_order==4) {
		if(@$words_left==1) {
		    # l[-1] || r[0] :: p(r[0] | l[-1])
		    $lm_string=$words_left->[-1] . ' ' . $words_right->[0];
		    $sum+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
		    if(@$words_right>=2) {
			# l[-1] || r[0] r[1] :: p(r[1] | l[-1] r[0])
			$lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
			$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		    }
		} elsif(@$words_left==2) {
		    # l[-2] l[-1] || r[0] :: p(r[0] | l[-2] l[-1])
		    $lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		    $sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		    if(@$words_right>=2) {
			# w w | w w  :: p(r[1] | l[-2] l[-1] r[0])
			$lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
			$sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		    }
		} else {
		    # w w w | w
		    $lm_string=$words_left->[-3] . ' ' . $words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		    $sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		    my $debug_prob=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		    print STDERR "lm_cost:get4gramProb_LM(lm_srilm_id,$lm_string,$cap)=$debug_prob\n";
		    if(@$words_right>=2) {
			# w w | w w
			$lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
			$sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		    }
		}
		
		if(@$words_right>2) {
		    # w | w w w
		    $lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1] . ' ' . $words_right->[2];
		    $sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
		    
		for(my $i=3; $i<@$words_right; $i++) {
		    $lm_string=$words_right->[$i-3] . ' ' . $words_right->[$i-2] . ' ' . $words_right->[$i-1] . ' ' . $words_right->[$i];
		    $sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
	    }
	}

	if($rescore_mode) {
	    $$individual_costs{'lm_weight'}+=$sum;
	    $total+=$sum;
	} else {
	    $total+=$sum*$lm_weight;
	}

#	$$individual_costs{'lm_weight'}+=$sum if($rescore_mode);
#	$total+=$sum*$lm_weight;

    }




#	my $l=join(" ",@$words_left);
#	my $r=join(" ",@$words_right);
#	print STDERR "p($l :: $r)=";
#	print STDERR "$total\n";
    	
    return $total;    
}

sub local_lm_cost {
    my($words_left,$words_right,$pos_left,$pos_right,$parameters,$features,$lm_vocab_ids,$rescore_mode,$individual_costs)=@_;
    my $cap=$parameters->{'lm_cap'};
    my $lm_order=$parameters->{'local_lm_order'};
    my $lm_string;
    my $total=0;

    my $lm_weight=$$features{'local_lm_weight'};

    my $sum=0; 
    
    if(@$words_right==0) {
	$sum+=&local_lm_ngram_prob($words_left,$pos_left,$cap,$parameters,$lm_vocab_ids);
	$total+=$sum*$lm_weight;
    }

}


sub local_lm_ngram_prob {
    my($words,$pos,$cap,$parameters,$lm_vocab_ids)=@_;

    my $local_lm_order=$parameters->{'local_lm_order'};

    my $lm_string;
    my $total=0;
    my $print_probs=0;

    my @local_histories;
    my @local_lm_ids;
    my @local_word_pos;

#    if(defined($words->[0]) && $words->[0] ne '<s>') {
#	$total+=srilm::get1gramProb_LM($lm_srilm_id,$words->[0],$cap);
#    }

    if(defined($words->[0])) {
	my $word_pos=$words->[0] . ' ' . $pos->[0];
	$word_pos=~tr/0-9/6/;
	my $lm_srilm_id=$$lm_vocab_ids{$word_pos};
	$lm_string=$words->[0];
	$lm_string=~tr/0-9/6/;
	
	if(!defined($$lm_vocab_ids{$word_pos}) || $$lm_vocab_ids{$word_pos}==1) {
	    print "no local lm for:$word_pos\n";
	    $total+=-10;
	    $lm_srilm_id='nil';
	} else {
	    $total+=0;
	}
	push(@local_histories,$lm_string);
	push(@local_lm_ids,$lm_srilm_id);
	push(@local_word_pos,$word_pos);
    }

    if(defined($words->[1])) {

	my $no_history_items=@local_histories;
	for(my $i=0; $i<$no_history_items; $i++) {
	    $lm_string=shift(@local_histories);
#	    print STDERR "shift: $lm_string\n";
	    $lm_string.= ' ' . $pos->[1];
	    my $lm_srilm_id=shift(@local_lm_ids);
#	    print STDERR "shift: $lm_srilm_id\n";
	    my $word_pos=shift(@local_word_pos);
	    if($lm_srilm_id eq 'nil') {
		$total+=-10;
		print "get2gramProb_LM([$word_pos],$lm_string,$cap)=-10 (no local lm)\n" if($print_probs);
	    } else {
		my $tmp_prob=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
		$total+=$tmp_prob;
		print "get2gramProb_LM([$word_pos],$lm_string,$cap)=$tmp_prob\n" if($print_probs);   
	    }
	    my @lm_string_tokens=split(/ /,$lm_string);
	    while(@lm_string_tokens>$local_lm_order-1) {
		shift(@lm_string_tokens);
	    }
	    my $next_lm_string=join(' ',@lm_string_tokens);
	    push(@local_histories,$next_lm_string);
#	    print STDERR "push: $lm_string\n";
	    push(@local_lm_ids,$lm_srilm_id);
#	    print STDERR "push: $lm_srilm_id\n";
	    push(@local_word_pos,$word_pos);
	}
	my $word_pos=$words->[1] . ' ' . $pos->[1];
	$word_pos=~tr/0-9/6/;

#	print STDERR "lm_vocab_ids{$word_pos}=$$lm_vocab_ids{$word_pos}\n";
	my $lm_srilm_id=$$lm_vocab_ids{$word_pos};
	$lm_string=$pos->[0] . ' ' . $words->[1];
	$lm_string=~tr/0-9/6/;

	if(!defined($$lm_vocab_ids{$word_pos}) || $$lm_vocab_ids{$word_pos}==1) {
	    $total+=-10;
	    $lm_srilm_id='nil';
	    print "get2gramProb_LM([$word_pos],$lm_string,$cap)=-10 (no local lm)\n" if($print_probs);
#	    print "no local lm for:$word_pos\n";
	} else {
	    my $tmp_prob=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    $total+=$tmp_prob;
	    print "get2gramProb_LM([$word_pos],$lm_string,$cap)=$tmp_prob\n" if($print_probs);	    
	}
	push(@local_histories,$lm_string);
#	print STDERR "push: $lm_string\n";
	push(@local_lm_ids,$lm_srilm_id);
#	print STDERR "push: $lm_srilm_id\n";
	push(@local_word_pos,$word_pos);

    }


    if(defined($words->[2])) {
#	print "3-gram: histories:", join('|',@local_histories), "\n";
	my $no_history_items=@local_histories;
	for(my $i=0; $i<$no_history_items; $i++) {
	    $lm_string=shift(@local_histories);
#	    print STDERR "shift: $lm_string\n";
	    $lm_string.= ' ' . $pos->[2];
	    my $lm_srilm_id=shift(@local_lm_ids);
#	    print STDERR "shift: $lm_srilm_id\n";
	    my $word_pos=shift(@local_word_pos);
	    if($lm_srilm_id eq 'nil') {
		$total+=-10;
		print "get3gramProb_LM([$word_pos],$lm_string,$cap)=-10 (no local lm)\n" if($print_probs);
	    } else {
		my $tmp_prob=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		$total+=$tmp_prob;
		print "get3gramProb_LM([$word_pos],$lm_string,$cap)=$tmp_prob\n" if($print_probs);	    
	    }
	    my @lm_string_tokens=split(/ /,$lm_string);
	    while(@lm_string_tokens>$local_lm_order-1) {
		shift(@lm_string_tokens);
	    }
	    my $next_lm_string=join(' ',@lm_string_tokens);
	    push(@local_histories,$next_lm_string);
#	    print STDERR "push: $lm_string\n";
	    push(@local_lm_ids,$lm_srilm_id);
#	    print STDERR "push: $lm_srilm_id\n";
	    push(@local_word_pos,$word_pos);
	}
	my $word_pos=$words->[2] . ' ' . $pos->[2];
	$word_pos=~tr/0-9/6/;
	my $lm_srilm_id=$$lm_vocab_ids{$word_pos};
	$lm_string=$pos->[0] . ' ' . $pos->[1] . ' ' . $words->[2];
	$lm_string=~tr/0-9/6/;
	if(!defined($$lm_vocab_ids{$word_pos}) || $$lm_vocab_ids{$word_pos}==1) {
	    $total+=-10;
	    $lm_srilm_id='nil';
	    print "get3gramProb_LM([$word_pos],$lm_string,$cap)=-10 (no local lm)\n" if($print_probs);
#	    print "no local lm for:$word_pos\n";
	} else {
	    my $tmp_prob=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    $total+=$tmp_prob;
	    print "get3gramProb_LM([$word_pos],$lm_string,$cap)=$tmp_prob\n" if($print_probs); 
	}
	push(@local_histories,$lm_string);
#	print STDERR "push: $lm_string\n";
	push(@local_lm_ids,$lm_srilm_id);
#	print STDERR "push: $lm_srilm_id\n";
	push(@local_word_pos,$word_pos);

   }

    if(defined($words->[3])) {
#	print "4-gram: histories:", join('|',@local_histories), "\n";
	my $no_history_items=@local_histories;
	for(my $i=0; $i<$no_history_items; $i++) {
	    $lm_string=shift(@local_histories);
#	    print STDERR "shift: $lm_string\n";
	    $lm_string.= ' ' . $pos->[3];
	    my $lm_srilm_id=shift(@local_lm_ids);
#	    print STDERR "shift: $lm_srilm_id\n";
	    my $word_pos=shift(@local_word_pos);
	    if($lm_srilm_id eq 'nil') {
		$total+=-10;
		print "get4gramProb_LM([$word_pos],$lm_string,$cap)=-10 (no local lm)\n" if($print_probs);
	    } else {
		my $tmp_prob=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		$total+=$tmp_prob;
		print "get4gramProb_LM([$word_pos],$lm_string,$cap)=$tmp_prob\n" if($print_probs);
	    }
	    my @lm_string_tokens=split(/ /,$lm_string);
	    while(@lm_string_tokens>$local_lm_order-1) {
		shift(@lm_string_tokens);
	    }
	    my $next_lm_string=join(' ',@lm_string_tokens);
#	    print STDERR "push: $lm_string\n";
	    push(@local_histories,$next_lm_string);
#	    print STDERR "push: $lm_srilm_id\n";
	    push(@local_lm_ids,$lm_srilm_id);
	    push(@local_word_pos,$word_pos);
	}
	my $word_pos=$words->[3] . ' ' . $pos->[3];
	$word_pos=~tr/0-9/6/;
	my $lm_srilm_id=$$lm_vocab_ids{$word_pos};
	$lm_string=$pos->[0] . ' ' . $pos->[1] . ' ' . $pos->[2] . ' ' . $words->[3];
	$lm_string=~tr/0-9/6/;
	if(!defined($$lm_vocab_ids{$word_pos}) || $$lm_vocab_ids{$word_pos}==1) {
	    $total+=-10;
	    $lm_srilm_id='nil';
	    print "get4gramProb_LM([$word_pos],$lm_string,$cap)=-10 (no local lm)\n" if($print_probs);
#	    print "no local lm for:$word_pos\n";
	} else {
	    my $tmp_prob=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    $total+=$tmp_prob;
	    print "get4gramProb_LM([$word_pos],$lm_string,$cap)=$tmp_prob\n" if($print_probs);
	}
#	print STDERR "push: $lm_string\n";
	push(@local_histories,$lm_string);
#	print STDERR "push: $lm_srilm_id\n";
	push(@local_lm_ids,$lm_srilm_id);
	push(@local_word_pos,$word_pos);

    }

    for(my $i=4; $i<@$words; $i++) {
	my $no_history_items=@local_histories;
#	print "5-gram: histories:", join('|',@local_histories), "\n";
	for(my $j=0; $j<$no_history_items; $j++) {
	    my $lm_string=shift(@local_histories);
	    $lm_string.= ' ' . $pos->[$i];
	    my $lm_srilm_id=shift(@local_lm_ids);
	    my $word_pos=shift(@local_word_pos);
	    if($lm_srilm_id eq 'nil') {
		$total+=-10;
		print "get5gramProb_LM([$word_pos],$lm_string)=-10 (no local lm)\n" if($print_probs);
	    } else {
#		print STDERR "1 srilm::get5gramProb_LM($lm_srilm_id,$lm_string,$cap);\n";
		my $tmp_prob=srilm::get5gramProb_LM($lm_srilm_id,$lm_string,$cap);
		print "get5gramProb_LM([$word_pos],$lm_string)=$tmp_prob\n" if($print_probs);
		$tmp_prob=-10 if($tmp_prob<-10);
		$total+=$tmp_prob;
#		$total+=srilm::get5gramProb_LM($lm_srilm_id,$lm_string,$cap);		
	    }
	    my @lm_string_tokens=split(/ /,$lm_string);
	    while(@lm_string_tokens>$local_lm_order-1) {
		shift(@lm_string_tokens);
	    }
	    $lm_string=join(' ',@lm_string_tokens);
	    push(@local_histories,$lm_string);
	    push(@local_lm_ids,$lm_srilm_id);
	    push(@local_word_pos,$word_pos);
	}

	shift(@local_histories);
	shift(@local_lm_ids);
	shift(@local_word_pos);
 
	my $word_pos=$words->[$i] . ' ' . $pos->[$i];
	$word_pos=~tr/0-9/6/;
	my $lm_srilm_id=$$lm_vocab_ids{$word_pos};
	my $lm_string=$pos->[$i-4] . ' ' . $pos->[$i-3] . ' ' . $pos->[$i-2] . ' ' . $pos->[$i-1] . ' ' . $words->[$i];
	$lm_string=~tr/0-9/6/;
	if(!defined($$lm_vocab_ids{$word_pos}) || $$lm_vocab_ids{$word_pos}==1) {
	    $total+=-10;
	    $lm_srilm_id='nil';
	    print "get5gramProb_LM([$word_pos],$lm_string)=-10 (no local lm)\n" if($print_probs);
#	    print "no local lm for:$word_pos\n";
	} else {
#	    print STDERR "2 srilm::get5gramProb_LM($lm_srilm_id,$lm_string,$cap);\n";
	    my $tmp_prob=srilm::get5gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    print "get5gramProb_LM([$word_pos],$lm_string)=$tmp_prob\n" if($print_probs);
#	    $tmp_prob=-10 if($tmp_prob<-10);
	    $total+=$tmp_prob;
#	    $total+=srilm::get5gramProb_LM($lm_srilm_id,$lm_string,$cap);
	}
	my @lm_string_tokens=split(/ /,$lm_string);
	while(@lm_string_tokens>$local_lm_order-1) {
	    shift(@lm_string_tokens);
	}
	$lm_string=join(' ',@lm_string_tokens);
	push(@local_histories,$lm_string);
	push(@local_lm_ids,$lm_srilm_id);
	push(@local_word_pos,$word_pos);

#	shift(@local_histories);
#	shift(@local_lm_ids);
#	shift(@local_word_pos);
    }	

 #   print STDERR "total=$total\n";
    return $total;
}



sub lm_cost_between {
    my($words_left,$words_right,$parameters,$features,$lm_srilm_ids,$rescore_mode,$individual_costs)=@_;
    my $cap=$parameters->{'lm_cap'};
    my $lm_order=$parameters->{'lm_order'};
    my $lm_string;
    my $total=0;

#    my $lm_weight=$$features{'lm_weight_between'};
    my $lm_weight=$$features{'lm_weight'};

    for(my $lm_index=0; $lm_index<@$lm_srilm_ids; $lm_index++) {
	my $lm_srilm_id=$lm_srilm_ids->[$lm_index];
	
	my $sum=0; 

	if($lm_order==3) {
	    if(@$words_left==1) {
		$lm_string=$words_left->[-1] . ' ' . $words_right->[0];
		$sum+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    } else {
		$lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    }
	    
	    if(@$words_right>1) {
		$lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    }	
	} elsif($lm_order==4) {
	    if(@$words_left==1) {
		# w | w
		$lm_string=$words_left->[-1] . ' ' . $words_right->[0];
		$sum+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
		if(@$words_right>=2) {
		    # w | w w
		    $lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
		    $sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
	    } elsif(@$words_left==2) {
		# w w | w
		$lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		my $debug_prob=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		print STDERR "lm_cost_between:get3gramProb_LM(lm_srilm_id,$lm_string,$cap)=$debug_prob\n";
		if(@$words_right>=2) {
		    # w w | w w
		    $lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
		    $sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		}
	    } else {
		# w w w | w
		$lm_string=$words_left->[-3] . ' ' . $words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0];
		$sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
		if(@$words_right>=2) {
		    # w w | w w
		    $lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
		    $sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		    my $debug_prob=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
#		    print STDERR "lm_cost_between:get4gramProb_LM(lm_srilm_id,$lm_string,$cap)=$debug_prob\n";

		}
	    }

#	    if(@$words_left>1 && @$words_right>1) {
#		$lm_string=$words_left->[-2] . ' ' . $words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1];
#		$sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
#	    }

	    if(@$words_right>2) {
		# w | w w w
		$lm_string=$words_left->[-1] . ' ' . $words_right->[0] . ' ' . $words_right->[1] . ' ' . $words_right->[2];
		$sum+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    }			   
	}
    
#        $$individual_costs{'lm_weight_between'}+=$sum if($rescore_mode);
        $$individual_costs{'lm_weight'}+=$sum if($rescore_mode);
       
	$total+=$sum;
    }
    
#    my $l=join(" ",@$words_left);
#    my $r=join(" ",@$words_right);
#    print STDERR " p($l :: $r)=";
#    print STDERR "$total\n";

    if($rescore_mode) {
    } else {
	$total*=$lm_weight;
    }

    return $total;
}




sub lm_cost_thread {
    my($words_left,$words_right,$lm_id)=@_;
    my $cap=0;
    my $lm_string;
    my $total=0;
    my $lm_weight=1;

    print STDERR "foo\n";
    my $l=join(" ",@$words_left);
    my $r=join(" ",@$words_right);
    print STDERR "p($l :: $r)=\n";

#    for(my $lm_index=0; $lm_index<@lm_srilm_ids; $lm_index++) {
#	my $lm_srilm_id=$lm_srilm_ids[$lm_index];
		
	my $sum=0; 

	if(@$words_right==0) {
	    $sum+=&lm_ngram_prob($lm_srilm_id,$words_left,$cap);
	} else {
	    $lm_string=$words_left->[-1] . " " . $words_right->[0];
	    print STDERR "2gram\n";
	    $sum+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    if(@$words_left>1) {
		$lm_string=$words_left->[-2] . " " . $words_left->[-1] . " " . $words_right->[0];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    }
	    if(@$words_right>1) {
		$lm_string=$words_left->[-1] . " " . $words_right->[0] . " " . $words_right->[1];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    }
	
	    for($i=2; $i<@$words_right; $i++) {
		$lm_string=$words_right->[$i-2] . " " . $words_right->[$i-1] . " " . $words_right->[$i];
		$sum+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	    };
#	}

	$total+=$sum*$lm_weight;

	my $l=join(" ",@$words_left);
	my $r=join(" ",@$words_right);
	print STDERR "p($l :: $r)=";
	print STDERR "$total\n";
	
	return $total;
    }
}


sub lm_ngram_prob {
    my($words,$lm_srilm_id);
    ($lm_srilm_id,$words,$cap,$parameters)=@_;

    my $lm_order=$parameters->{'lm_order'};

    my $lm_string;
    my $total=0;

    if(defined($words->[0]) && $words->[0] ne '<s>') {
	$total+=srilm::get1gramProb_LM($lm_srilm_id,$words->[0],$cap);
    }
    if(defined($words->[1])) {
	$lm_string=$words->[0] . ' ' . $words->[1];
	$total+=srilm::get2gramProb_LM($lm_srilm_id,$lm_string,$cap);
    }
    
    if($lm_order==3) {
	for(my $i=2; $i<@$words; $i++) {
	    $lm_string=$words->[$i-2] . ' ' . $words->[$i-1] . ' ' . $words->[$i];
	    $total+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	}
    } elsif($lm_order==4) {
	if(defined($words->[2])) {
	    $lm_string=$words->[0] . ' ' . $words->[1] . ' ' . $words->[2];
	    $total+=srilm::get3gramProb_LM($lm_srilm_id,$lm_string,$cap);
	}
	for(my $i=3; $i<@$words; $i++) {
	    $lm_string=$words->[$i-3] . ' ' . $words->[$i-2] . ' ' . $words->[$i-1] . ' ' . $words->[$i];
	    $total+=srilm::get4gramProb_LM($lm_srilm_id,$lm_string,$cap);
	}       
    }

    return $total;
}




return 1;
