
sub print_lattice {

    my($node_id,$stack,$nodes_recomb_back,$nodes_back,$nodes_tr,$nodes_cos,$nodes_cos_nolm,$nodes_lpos,$nodes_rpos,$sent_id,$lattice_file,$generate_rescore_lattice)=@_;

    my $final_node=$node_id+1;
    my @queue;
    my %visited;
    my $max_recombined=100;
    
    open(LATTICE,">$lattice_file");
    print LATTICE "<SENT ID=$sent_id>\n";
    print LATTICE "$final_node\t$stack->[-1][0]\|\|\|\|\|\|0";
    for(my $j=1; $j<@{ $stack->[-1] }; $j++) {
	    print LATTICE " $stack->[-1][$j]\|\|\|\|\|\|0";
    };
    print LATTICE "\n";
	
    for(my $j=0; $j<@{ $stack->[-1] }; $j++) {
	push(@queue,$stack->[-1][$j]);	
    };

    while(@queue>0) {
	my $lattice_node_id=shift(@queue);
	next if($lattice_node_id==0);
	    
	if(!defined($visited{$lattice_node_id})) {
#	    print STDERR "nodes_cos->[$lattice_node_id]=$nodes_cos->[$lattice_node_id]-nodes_cos->[$nodes_back->[$lattice_node_id]]=$nodes_cos->[$nodes_back->[$lattice_node_id]]\n";
	    print LATTICE "$lattice_node_id\t$nodes_back->[$lattice_node_id]\|\|\|$nodes_tr->[$lattice_node_id]\|\|\|";
	    if($generate_rescore_lattice) {
#		if(!defined($nodes_cos_nolm->[$lattice_node_id])) {
#		    print STDERR "undef: nodes_cos_nolm->[$lattice_node_id]\n";
#		}
#		if(!defined($nodes_cos_nolm->[$nodes_back->[$lattice_node_id]])) {
#		    print STDERR "undef: nodes_cos_nolm->[nodes_back->[$lattice_node_id]\n";
#		}
		print LATTICE $nodes_cos_nolm->[$lattice_node_id]-$nodes_cos_nolm->[$nodes_back->[$lattice_node_id]];
	    } else {
		print LATTICE $nodes_cos->[$lattice_node_id]-$nodes_cos->[$nodes_back->[$lattice_node_id]];
	    }
	    push(@queue,$nodes_back->[$lattice_node_id]);
	} else {
	    next;
	}


	my $no_recombined=0;
	foreach my $recomb_lattice_node_id (keys %{ $nodes_recomb_back->[$lattice_node_id] }) {

	    print LATTICE " $nodes_back->[$recomb_lattice_node_id]|||$nodes_tr->[$recomb_lattice_node_id]|||";
	    if($generate_rescore_lattice) {
		# 
		# print LATTICE $nodes_cos_nolm->[$recomb_lattice_node_id]-$nodes_cos_nolm->[$nodes_back->[$recomb_lattice_node_id]] , "";
		print LATTICE $nodes_recomb_back->[$lattice_node_id]{$recomb_lattice_node_id} , "";
	    } else {
		# buggy:
		# print LATTICE $nodes_cos->[$recomb_lattice_node_id]-$nodes_cos->[$nodes_back->[$recomb_lattice_node_id]] , "";
		# fixed:
		print LATTICE $nodes_recomb_back->[$lattice_node_id]{$recomb_lattice_node_id} , "";
	    }
	    next if(defined($visited{$nodes_back->[$recomb_lattice_node_id]}));
	    last if($no_recombined>$max_recombined);		
	    push(@queue,$nodes_back->[$recomb_lattice_node_id]);
	    $no_recombined++;
	}


	print LATTICE "\n";
	$visited{$lattice_node_id}=1;
    }
	
    print LATTICE "<COVERVECS>";
    my $cover_string="";
    foreach my $id (keys %visited) {
	next if($id==0);
#	print STDERR "covervecs: visited node_id=$id";
	$cover_string.="$id-$nodes_back->[$id]:$nodes_lpos->[$id]:$nodes_rpos->[$id] ";
	foreach my $recomb_id (keys %{ $nodes_recomb_back->[$id] }) {
	    $cover_string.="$id-$nodes_back->[$recomb_id]:$nodes_lpos->[$recomb_id]:$nodes_rpos->[$recomb_id] ";
#	    print STDERR "recomb=$recomb_id(back=$nodes_back->[$recomb_id]"; 
	}
#	print STDERR "\n";
    }
    $cover_string=~s/ $//o;
    print LATTICE "$cover_string</COVERVECS>\n";
    print LATTICE "</SENT>\n";
}


return 1;
