
sub sort_and_prune_stack {
    my($no_f_words_covered,$f_tokens,$stack,$nodes_tc,$nodes_cos,$nodes_cos_nolm,$nodes_last,$nodes_cov,$nodes_lpos,$nodes_rpos,$nodes_tr,$nodes_label,$max_in_stack,$min_in_full_stack,$nodes_back,$nodes_recomb_back,$recombine_info,$parameters,$future_cost_spans,$nodes_favorite_child_cost,$rescore_lattice,$generate_rescore_lattice)=@_;

    my $beam_width=log($$parameters{'beam_width'});
    my $children_beam_width=log($$parameters{'children_beam_width'});
    my $stack_size=$$parameters{'stack_size'};
    my $current_stack_size=0;
    my $min_prune_stack_size=$$parameters{'min_prune_stack_size'};
    my $min_stack_size=20;

#    print STDERR "start pruning from stack ", $no_f_words_covered+1, "\n";
    for(my $i=$no_f_words_covered+1; $i<=@$f_tokens; $i++) {
	next if(!defined($stack->[$i]));

	if($i>$no_f_words_covered+1 && @{ $stack->[$i] }<$min_prune_stack_size) {
	    next;
	}


	if(0) {
	print STDERR "unsorted_stack[$i]=";
	for(my $k=0; $k<@{ $stack->[$i] }; $k++) {
	    print STDERR " tc[$k]=$nodes_tc->[$stack->[$i][$k]]";
	}
	print STDERR "\n";
	}

	my @sorted_stack = sort ( {-1*( $nodes_tc->[$a]<=>$nodes_tc->[$b])} @{ $stack->[$i] });
	my $no_recombinations=0;

	undef @{ $stack->[$i] };
	undef $min_in_full_stack->[$i];

#	my $no_elements=@sorted_stack;
#	print STDERR "  before pruning: sorted_stack[$i]=$no_elements\n";
#	print STDERR "sorted_stack[$i]=", join(" ",@sorted_stack), "\n";

	if(@sorted_stack>0) {
	    $max_in_stack->[$i]=$nodes_tc->[$sorted_stack[0]];
	    push(@{ $stack->[$i] }, $sorted_stack[0]);
	    $current_stack_size++;
	    my $recombine_string= join(' ', @{ $nodes_last->[$sorted_stack[0]]}) 
		. ':' . $nodes_cov->[$sorted_stack[0]] 
		. ':' . $nodes_rpos->[$sorted_stack[0]];
	    $$recombine_info{$recombine_string}=$sorted_stack[0];
	} else {
	    next;
	}


	for(my $j=1; $j<@sorted_stack && $current_stack_size<=$stack_size; $j++) {
	    my $recombine_string= join(' ', @{ $nodes_last->[$sorted_stack[$j]]}) 
                           . ':' . $nodes_cov->[$sorted_stack[$j]] 
			   . ':' . $nodes_rpos->[$sorted_stack[$j]];

#	    print STDERR "nodes_favorite_child_cost->[$nodes_back->[$sorted_stack[$j]]]=$nodes_favorite_child_cost->[$nodes_back->[$sorted_stack[$j]]]+$children_beam_width\n";
#	    if($nodes_tc->[$sorted_stack[$j]]<$nodes_favorite_child_cost->[$nodes_back->[$sorted_stack[$j]]]+$children_beam_width) {
#		next;
#	    }

#	    &print_state($sorted_stack[$j],$f_tokens,$stack,$nodes_lpos,$nodes_rpos,$nodes_last,$nodes_cov,$nodes_cos,$nodes_tc,$nodes_back,$nodes_tr,$future_cost_spans);
	    if($current_stack_size>$min_stack_size &&
		(((defined($max_in_stack->[$i]) && $nodes_tc->[$sorted_stack[$j]]<$max_in_stack->[$i]+$beam_width)
		  || (defined($min_in_full_stack->[$i]) && $nodes_tc->[$sorted_stack[$j]]<$min_in_full_stack->[$i])))) {
		last;
# attempt to keep recombinable states:
#		$recombine_only=1;
	    } else {

#	    if(&within_beam($nodes_tc->[$sorted_stack[$j]],$max_in_stack,$min_in_full_stack,$i,$beam_width)==1) {
	    
		if(defined($combine_node=$$recombine_info{$recombine_string}) && $combine_node!=$sorted_stack[$j]) {
		    # buggy:
		    # $nodes_recomb_back->[$combine_node]{$sorted_stack[$j]}=1;
		    # Fixed. Compute cost difference here:
		    if($generate_rescore_lattice) {
			$nodes_recomb_back->[$combine_node]{$sorted_stack[$j]}=$nodes_cos_nolm->[$sorted_stack[$j]]-$nodes_cos_nolm->[$nodes_back->[$sorted_stack[$j]]];
		    } else {
			$nodes_recomb_back->[$combine_node]{$sorted_stack[$j]}=$nodes_cos->[$sorted_stack[$j]]-$nodes_cos->[$nodes_back->[$sorted_stack[$j]]];
		    }
		    $no_recombinations++;
		    if($rescore_lattice) {
			$nodes_label->[$sorted_stack[$j]]=$nodes_label->[$combine_node];
		    }
		} elsif($nodes_tc->[$sorted_stack[$j]]<$nodes_favorite_child_cost->[$nodes_back->[$sorted_stack[$j]]]+$children_beam_width) {
#		    print STDERR "Outside of child beam: $sorted_stack[$j]\n";
		    next;
		} else {
		    if($current_stack_size==$stack_size) {
			$current_stack_size++;
			$min_in_full_stack->[$i]=$nodes_tc->[$sorted_stack[$j]];
		    } else {
			push(@{ $stack->[$i] }, $sorted_stack[$j]);
			$current_stack_size++;
			$$recombine_info{$recombine_string}=$sorted_stack[$j];
		    }
		}
	    }
	}
#	$no_elements=@{ $stack->[$i] };
#	print STDERR "  after pruning: stack[$i]=$no_elements\n";
    }
#    print STDERR "\n";
}

#		    &print_state($sorted_stack[$j],$f_tokens,$stack,$nodes_lpos,$nodes_rpos,$nodes_last,$nodes_cov,$nodes_cos,$nodes_tc,$nodes_back,$nodes_tr,$future_cost_spans);
#	    }
		    		
#		if(defined($combine_node=$$recombine_info{$recombine_string})
#		   && $combine_node!=$sorted_stack[$j]
#		   && !defined($nodes_recomb_back->[$combine_node]{$sorted_stack[$j]})) {
#		    $nodes_recomb_back->[$combine_node]{$sorted_stack[$j]}=1;
#		} else {
#		    push(@{ $stack->[$i] }, $sorted_stack[$j]);
#		    $current_stack_size++;
#		}			       		  		

#	    } else {
#		last;
#	    }
	    

#	$no_elements=@{ $stack->[$i] };
#	print STDERR "after  pruning: sorted_stack[$i]=$no_elements (recombined=$no_recombinations)\n";

#	if($no_elements==1) {
#	    print STDERR "sorted_stack[$i]=\n";
#	    for(my $k=0; $k<@sorted_stack; $k++) {
#		print STDERR " tc[$k]=$nodes_tc->[$sorted_stack[$k]]";
#	    }
#	    print STDERR "\n";
#	    print STDERR "Pruned stack[$i]=$nodes_tc->[$stack->[$i][0]]\n";
#	}


#	print STDERR "pruned_stack[$i]=", join(" ",@{ $stack->[$i] }), "\n";

	    
#    }
#}

return 1;
