
sub read_lattice_file {

    my($lattice_file,$lattice,$lattice_translations,$lattice_costs)=@_;

    open(L,"<$$lattice_file")||die("can't open file $$lattice_file: $!\n");
    while(defined(my $line=<L>)) {
	if($line=~/^<SENT ID=([0-9]+)>/o) {
	    $sent_id=$1;

	    my %edges;
	    my %translations;

	    while(defined($line=<L>) && $line!~/^<COVERVECS>/o) {
		my($to_node,$from_node_string)=$line=~/^([0-9]+)\t(.+)\n/o;
		while($from_node_string=~s/([0-9]+)\|\|\|([^\|]*)\|\|\|([^ ]+)//o) {
		    my $from_node=$1;
		    my $translation=$2;
		    my $cost=$3;
		    $translation='NIL' if(!defined($translation)||$translation eq '');
		    $$lattice_translations{$from_node}{$to_node}=$translation;
		    $$lattice_costs{$from_node}{$to_node}=$cost;
#		    print STDERR "lattice_translations{$from_node}{$to_node}=$translation\n";
		}
	    }
	    if($line=~/^<COVERVECS>/o) {
		$line=~s/^<COVERVECS>//o;
		$line=~s/<\/COVERVECS>\n//o;
		my @covers=split(/ /,$line);
		for(my $i=0 ;$i<@covers; $i++) {
		    my($to,$from,$f_i,$f_j)=$covers[$i]=~/^([0-9]+)\-([0-9]+)\:([0-9]+)\:([0-9]+)$/o;
		    $$lattice{$from}{$to}=$f_i . ' ' . $f_j;
#		    print STDERR "lattice{$from}{$to}=$$lattice{$from}{$to}\n"
		}
	    }
	}
    }
}


return 1;
