
sub translate_sentence {

    my($f_tokens,$rescore_mode,$generate_rescore_lattice,$rescore_lattice,$rescore_lattice_sentence_file,$nbest_sent,$nbest_sent_rank,$parameters,$features,$feature_order,$lm_srilm_ids,$sent_id,$lattice_dir,$rescored_sents,$lm_cache,$lm_between_cache)=@_;
    
    my($cover_string,$final_trans);
    #all the variables to store individual costs/features/info
    my(@nodes_lpos,@nodes_rpos,@nodes_last,@nodes_cov,@nodes_cos,@nodes_tc,@nodes_back,@nodes_tr,@nodes_recomb_back,@nodes_cos_nolm,%recombine_info,@nodes_favorite_child_cost,@nodes_label);


    my @match_trans;
    my @future_cost_spans;
    my @stack;
    my @max_in_stack;
    my @min_in_full_stack;
    my @nbest_trans_map;
    my @translation_order;
    my $node_id;

    my %individual_costs;

#    my %lm_cache;
#    my %lm_between_cache;
    my %e_phrase_prefixes;
    undef @nodes_lpos; 
    undef @nodes_rpos;
    undef @nodes_last;
    undef @nodes_cov;
    undef @nodes_cos;
    undef @nodes_tc;
    undef @nodes_back;
    undef @nodes_tr;
    undef @nodes_recomb_back;
    undef @nodes_cos_nolm;
    undef @nodes_label;
    undef @nodes_favorite_child_cost;

    undef %recombine_info;
    my %lattice;
    my %lattice_translations;
    my %lattice_costs;

    #TO-DO: sort out the file paths
    if($rescore_lattice) {
	&read_lattice_file($rescore_lattice_sentence_file,\%lattice,\%lattice_translations,\%lattice_costs);
    }

    my $stack_size;
    &find_matching_translations($f_tokens,$parameters,\@match_trans,$rescore_mode,$nbest_sent,\@nbest_trans_map,\@translation_order,\%e_phrase_prefixes);

    if(!$rescore_mode) {
	$stack_size=$$parameters{'stack_size'};
	&initialize_future_cost_spans($f_tokens,\@match_trans,\@future_cost_spans,$parameters);
    }

    &initialize_stack($f_tokens,\$node_id,\@stack,\@future_cost_spans,\@nodes_lpos,\@nodes_rpos,\@nodes_last,\@nodes_cov,\@nodes_cos,\@nodes_cos_nolm,\@nodes_tc,\@nodes_back,\@nodes_tr,\@nodes_recomb_back,\@nodes_favorite_child_cost,\@nodes_label,$rescore_lattice);
    
    for(my $no_f_words_covered=0; $no_f_words_covered<@$f_tokens; $no_f_words_covered++) {

	next if(!defined($stack[$no_f_words_covered]));
	for(my $node_in_stack=0; $node_in_stack<@{ $stack[$no_f_words_covered] }; $node_in_stack++) {
	    
	    &expand_node($no_f_words_covered,$node_in_stack,$f_tokens,\$node_id,\@stack,\@max_in_stack,\@min_in_full_stack,\@match_trans,\@future_cost_spans,\@nodes_lpos,\@nodes_rpos,\@nodes_last,\@nodes_cov,\@nodes_cos,\@nodes_tc,\@nodes_back,\@nodes_tr,\@nodes_recomb_back,\@nodes_cos_nolm,\%recombine_info,$parameters,$features,$lm_srilm_ids,$nbest_sent,$rescore_mode,$generate_rescore_lattice,$rescore_lattice,\@nbest_trans_map,\@translation_order,\%individual_costs,$lm_cache,$lm_between_cache,\%e_phrase_prefixes,\@nodes_favorite_child_cost,\@nodes_label,\%lattice,\%lattice_translations,\%lattice_costs,$sent_id);

	}

	if(!$rescore_mode) {
	    &sort_and_prune_stack($no_f_words_covered,$f_tokens,\@stack,\@nodes_tc,\@nodes_cos,\@nodes_cos_nolm,\@nodes_last,\@nodes_cov,\@nodes_lpos,\@nodes_rpos,\@nodes_tr,\@nodes_label,\@max_in_stack,\@min_in_full_stack,\@nodes_back,\@nodes_recomb_back,\%recombine_info,$parameters,\@future_cost_spans,\@nodes_favorite_child_cost,$rescore_lattice,$generate_rescore_lattice);
	}
    }

    if(!defined($stack[@$f_tokens][0])) {
	print STDERR "UNDEF sent_id=$sent_id nbest_sent_rank=$nbest_sent_rank\n";
    }


#    my $stack_size_memory=size(\@stack);
#    print STDERR "total stack size=$stack_size_memory\n";

    my $final_translation='';
    if($rescore_mode) {
	$rescored_sentence=&return_rescored_sentence($nbest_sent,\%individual_costs,$feature_order);
	push(@$rescored_sents,$rescored_sentence);
    } else {
	$final_translation=&return_translation($stack[@$f_tokens][0],\@stack,$f_tokens,\@nodes_tr,\@nodes_back);
	print STDERR "final_translation=$final_translation\n";
	my $lattice_file="$lattice_dir/$sent_id.lattice";

	#set generate_rescore_lattice=0 (last argument)
	&print_lattice($node_id,\@stack,\@nodes_recomb_back,\@nodes_back,\@nodes_tr,\@nodes_cos,\@nodes_cos_nolm,\@nodes_lpos,\@nodes_rpos,$sent_id,$lattice_file,0) if($print_lattice);
	
	if($generate_rescore_lattice) {
	    &print_lattice($node_id,\@stack,\@nodes_recomb_back,\@nodes_back,\@nodes_tr,\@nodes_cos,\@nodes_cos_nolm,\@nodes_lpos,\@nodes_rpos,$sent_id,"$lattice_file.nolm",$generate_rescore_lattice);
	}
	my $stack_utilization=0;
	for(my $i=1; $i<=@$f_tokens; $i++) {
	    next if(!defined($stack[$i]));
	    $stack_utilization+=@{ $stack[$i] }/$stack_size;
	}
	if(@$f_tokens>0) {
	    $stack_utilization/=@$f_tokens;
	    printf STDERR "stack utilization=%.2f", 100*$stack_utilization;
	    print STDERR "\%\n";
	} else {
	    print STDERR "stack utilization=n\/a\%\n";
	}
    }

    undef %e_phrase_prefixes;
    undef @stack;
    undef @match_trans;

    undef @nodes_lpos; 
    undef @nodes_rpos;
    undef @nodes_last;
    undef @nodes_cov;
    undef @nodes_cos;
    undef @nodes_tc;
    undef @nodes_back;
    undef @nodes_tr;
    undef @nodes_recomb_back;
    undef @nodes_cos_nolm;
    undef @nodes_label;
    undef @nodes_favorite_child_cost;

    undef %recombine_info;

    return $final_translation;
}


return 1;
